import processing.opengl.*;
////TODO -
// parameter: long & thin vs short & fat (base pitch?)
// parameter: pinch one end, flare the other (volume?)
//
// reduce ripple radius as # of ripples increase (to reduce overhang)
// twist should go both CW and CCW
// thinner 2nd-order circumferential ripples?
// 
//
// try varying layer height - a little higher to avoid squishing?



// first try using processing to make gcode for helix tubes

/// adding - visualizing the tube in 3d


// voice input stuff
import beads.*;

AudioContext ac;
PowerSpectrum ps;

SpectralPeaks peaks;
Frequency freqs;

float[][] peakfeats;
float[][] sigfeats;

boolean USEVOICE = true;

int PASTLEN = 10;
int lastPast = 0;
float [][] pastParams = new float[PASTLEN][6];

float[] savedParams;


// geometry and gcode stuff
String outfile = "tube.gcode";

PImage savedImg;


int numLayers = 100;

int XBIAS = 0;
int YBIAS = 0;

float XSHIFT = 0;
float YSHIFT = 0;

float XRAND = 30;
float YRAND = 30;


/*
float layerHeight = 0.4;   // mm
float feedRate = 10.0;     // mm/sec
float extruderReverseSpeed = 35.0;
float extruderForwardSpeed = 0.6142;
*/

Boolean saving = false;

/*
float layerHeight = 0.4;
float feedRate = 30.0;
float extruderReverseSpeed = 35.0;
float extruderForwardSpeed = 1.843;
*/

/*
float layerHeight = 0.4;
float feedRate = 20.0;
float extruderReverseSpeed = 35.0;
float extruderForwardSpeed = 1.22;
*/
float layerHeight = 0.4;
float initialFeedRate = 11.0;
float finalFeedRate = 13.0;
float extruderReverseSpeed = 35.0;
float initialExtruderSpeed = 0.9;
float finalExtruderSpeed = 0.9;

float extruderForwardSpeed = initialExtruderSpeed;
float feedRate = initialFeedRate;

int subdivisions = 36;  // how much to divide up the circle

float perimeterSize = 26; // size of perimeter wipe rectangle 

float thisLayer[][] = new float[subdivisions][3];
float previousLayer[][];// = new float[subdivisions][3];


String prefile = "start.gcode";
String postfile = "end.gcode";


PrintWriter output;


void setup() {
  size(screen.width,screen.height,OPENGL);
  
  background(128);
  lights();
  noStroke();
  camera(200, 1000, 0,   0, 0, 0,    0, 1, 0);
  
  setupVoiceInput();
  
  /*
  if (saving) output = createWriter(outfile);
  if (saving) copyFile(prefile);
  
  if (saving) drawPerimeter();
  
  //makeTube(4,5,0.2);
  
  
  if (saving) copyFile(postfile);

  if (saving) output.close();
  //exit();
  */
}

void setupVoiceInput() {
  ac = new AudioContext();
  
  JavaSoundAudioIO jsaio = (JavaSoundAudioIO)ac.getAudioIO();
  jsaio.selectMixer(0);
  /*
   * Here's something we've seen before...
   */
  //String audioFile = selectInput();
  SampleManager.setBufferingRegime(Sample.Regime.newStreamingRegime(1000));
  //SamplePlayer player = new SamplePlayer(ac, SampleManager.sample(audioFile));
  int zeroone[] = {0,1};
  UGen player = ac.getAudioInput(zeroone);

  Gain g = new Gain(ac, 2, 0.2);
  g.addInput(player);
  ac.out.addInput(g);
  
  println("---");
  jsaio.printMixerInfo();
  println("===");
  /*
   * To analyse a signal, build an analysis chain.
   */
  ShortFrameSegmenter sfs = new ShortFrameSegmenter(ac);
  sfs.addInput(ac.out);
  ////sfs.addInput(g);
  
  FFT fft = new FFT();
  ps = new PowerSpectrum();
  sfs.addListener(fft);
  fft.addListener(ps);
  ac.out.addDependent(sfs);
  ////g.addDependent(sfs);
  
  peaks = new SpectralPeaks(ac, 4);
  ps.addListener(peaks);
  
  freqs = new Frequency(ac.getSampleRate());
  ps.addListener(freqs);

  
  //and begin
  ac.start();
}


float t=0;

void mouseClicked() {
  savedParams = new float[6];
  savedParams[0]=a0;
  savedParams[1]=b0;
  savedParams[2]=c0;
  savedParams[3]=d0;
  savedParams[4]=e0;
  savedParams[5]=f0;
  
  XSHIFT = random(XRAND*2)-XRAND;
  YSHIFT = random(YRAND*2)-YRAND;
  saving = true;
  output = createWriter(outfile);
  copyFile(prefile);
  drawPerimeter();
  doTheTube();
  copyFile(postfile);
  output.close();
  saving = false;
  
  /*
  loadPixels();
  savedImg = createImage(screen.width, screen.height);
  savedImg.loadPixels();
  for (int i=0; i<savedImg.pixels.length; i++) {
    savedImg.pixels[i] = pixels[i];
  }
  */
  
}

float loFreq=10000;
float hiFreq = 0;
float loVal = 10000;
float hiVal = 0;

void draw() {
  background(0);
  
  // update time counter
  t += PI*2/200;
  
  
  // get voice features
  peakfeats = peaks.getFeatures();
  if (peakfeats != null) {
    int numSignificantPeaks=0;
    for (int i=0; i<peakfeats.length; i++) {
      if (peakfeats[i][1] > 0.1) {
        float f = peakfeats[i][0];
        float v = peakfeats[i][1];
        
        numSignificantPeaks++;
        stroke(255,255,255);
        int x = (int)f / 3;
        line(0,x,width*v,x);
        //println(i+" "+peakfeats[i][0]+"  " + peakfeats[i][1]);
        /*
        if (f < loFreq) loFreq = f;
        if (f > hiFreq) hiFreq = f;
        if (v < loVal) loVal = v;
        if (v > hiVal) hiVal = v;
        */
      }
    }
    // got f from 14 to 19000, almost always under 5000, usually under 1000
    // got v from 0 to 3.0, usually under 1.0
    //println("f: " + loFreq + " - " + hiFreq);
    //println("v: " + loVal + " - " + hiVal);
    //println("numSigPks " + numSignificantPeaks);
    
    sigfeats = new float[numSignificantPeaks][];
    int j=0;
    for (int i=0; i<peakfeats.length; i++) {
      if (peakfeats[i][1] > 0.1) {
        sigfeats[j] = peakfeats[i];
        j++;
        if (j>numSignificantPeaks) return;
      }
    }

  }
  
  
  //camera(800*sin(t), 500*cos(t), 500,   0, 0, 0,    0, 1, 0);

  //camera(mouseY*4, 500, mouseX*10-500,   0, 0, 0,    0, 0, 1);

  //rotateY(map(mouseX-width/2, 0, width, 0, PI));
  rotateZ(0);
  
  lights();
  noStroke();
  fill(204,255);
  /*
  lightSpecular(1.0,1.0,1.0);
  ambientLight(1.0,1.0,1.0);
  directionalLight(0.8, 0.8, 0.8, -1, 1, 0);
  */
    background(0); 
  
  // Light the bottom of the sphere
  directionalLight(51, 102, 126, 0, -1, 0);
  
  // Orange light on the upper-right of the sphere
  //spotLight(204, 153, 0, 360, 160, 600, 0, 0, -1, PI/2, 600); 
  
  // Moving spotlight that follows the mouse
  //spotLight(102, 153, 204, 360, mouseY, 600, 0, 0, -1, PI/2, 600); 
  
  
  //float s = mouseX / float(width);
  //specular(s,s,s);
  //translate(0,0,-50);
  ////rotateZ(t);
  //rotateX(sin(t/3)/1.0);
 
  rotateX(t/2);
 
  rotateY(PI/2.0);
  
  fill(204,255);
  doTheTube();
  
  translate(300,300,-180);
  scale(0.3);
  fill(99,255);
  if (savedParams!=null) {
    makeTube(savedParams[0],savedParams[1],savedParams[2],savedParams[3],savedParams[4],savedParams[5]);
  }
  scale(1.0);
  translate(0,0,0);
  
  rotateY(0);
  
  
  //translate(0,0,0);
  rotateZ(0);
  rotateX(0);
  
}

float a, b, c, d, e, f;
float a0, b0, c0, d0, e0, f0;
void doTheTube() {
  //makeTube(map(mouseX, 0,width,0.0,0.2), map(mouseY, 0,height, 0.0,8.0), 0);
  //makeTube(map(mouseX, 0,width,0.0,0.6), 5, map(mouseY, 0,height, 0.0,0.3), 1);
  //makeTube(map(mouseX, 0,width,0.0,0.6), 5, 0.1, map(mouseY,0,height,0,1), 1);
  //makeTube(map(mouseX, 0,width,0.0,1), 5, map(mouseY,0,height,0,1), 0, 0);
  if (USEVOICE) {
    if (sigfeats!=null) {
      if (sigfeats.length > 0) {
        a = map(sigfeats[0][0], 50, 2000, 0, 1);
        if (a<0) a=0;
        if (a>1) a=1;
        
        b = map(sigfeats[0][1], 0, 1, 0, 1);
        if (b<0) b=0;
        if (b>1) b=1;
      }
      if (sigfeats.length > 1) {
        c = map(sigfeats[1][0], 50, 2000, 0, 1);
        if (c<0) c=0;
        if (c>1) c=1;
        
        d = map(sigfeats[1][1], 0, 1, 0, 1);
        if (d<0) d=0;
        if (d>1) d=1;
      }
      if (sigfeats.length > 2) {
        e = map(sigfeats[2][0], 50, 2000, 0, 1);
        if (e<0) e=0;
        if (e>1) e=1;
        
        f = map(sigfeats[2][1], 0, 1, 0, 1);
        if (f<0) f=0;
        if (f>1) f=1;
      }
    }
    
    pastParams[lastPast][0] = a;
    pastParams[lastPast][1] = b;
    pastParams[lastPast][2] = c;
    pastParams[lastPast][3] = d;
    pastParams[lastPast][4] = e;
    pastParams[lastPast][5] = f;
    
    lastPast = (lastPast+1) % PASTLEN;
    
    float[] avg = new float[6];
    
    for (int i=0; i<PASTLEN; i++) {
      for (int j=0; j<6; j++) {
        avg[j] += pastParams[i][j] / PASTLEN;
      }
    }
    
    
    makeTube(avg[0],avg[1],avg[2],avg[3],avg[4],avg[5]);
    a0 = avg[0]; b0=avg[1]; c0=avg[2]; d0=avg[3]; e0=avg[4]; f0=avg[5];
    //makeTube(a,b,c,d,e,f);
  }
  else {
    makeTube(map(mouseX, 0,width,0.0,1), map(mouseY, 0,height, 0.0,1.0), map(mouseX, 0,width, 0.0,0.3), map(mouseY,0,height,0,1), map(mouseX,0,width,0,1), map(mouseY,0,height,0,1));
  }
}


// wavefreq 0-1: horizontal ripples
// crinklefreq 0-1: circumferential ripples
// twistfreq 0-0.3 or so: twist
// taper 0-1: cornucopiocity
// curvy 0-1: turn to the right
// squatty 0-1: short & fat or long * thin

void makeTube(float wavefreq, float crinklefreq, float twistfreq, float taper, float curvy, float squatty) {
  float Z = 0.5;
  
  comment("wf=" + wavefreq + ",  cf=" + crinklefreq + ", tf=" + twistfreq+ ", taper=" + taper + ", curvy="+curvy + ", squatty="+squatty);
  
  numLayers = (int)map(squatty, 0.0, 1.0, 110, 70);
  float baseRadius = map(squatty, 0.0, 1.0, 4.5, 7) + 1.6;
  
  // make 100 layers
  for (int i=0; i<numLayers; i++) {
    feedRate = map(i,0,numLayers/6,initialFeedRate, finalFeedRate);
    if (feedRate > finalFeedRate) feedRate = finalFeedRate;
    
    extruderForwardSpeed = map(i,0,numLayers/6,initialExtruderSpeed,finalExtruderSpeed);
    if (extruderForwardSpeed > finalExtruderSpeed) extruderForwardSpeed = finalExtruderSpeed;
    
    
    float radius = baseRadius+0.7*sin(i*wavefreq)/(1.0+3.0*wavefreq);
    if (saving) comment("layer " + i);
    extruderSpeed(extruderForwardSpeed);
    extruderForward();
    
    // note backwards map to put the fat end at the bottom of taper
    float taperness = exp(pow(map(i,0,numLayers,1.2,0.0) * taper, 0.7)) / (1+1.3*taper);

    for (int th=0; th < subdivisions; th++) {
      float ang = TWO_PI*th / subdivisions;
      float radius2 = radius*taperness + 0.7*sin(ang*(int)(crinklefreq*10.0)+i*twistfreq)/(1.0+2.0*twistfreq);
      float X = radius2 * cos(ang) + 2*curvy*sin(i*PI/numLayers);
      float Y = radius2 * sin(ang);
      
      G1(X,Y,Z,feedRate);
      
      
      thisLayer[th][0] = X*20;// + 400;
      thisLayer[th][1] = Y*20;// + 300;
      thisLayer[th][2] = (Z-numLayers*layerHeight/2)*20;// - 500;   
      
      
      // stay at the bottom for the first circle, so filament sticks
      if (i>0) Z += layerHeight/subdivisions;
   
    }
   

      
    // draw 3d preview
    beginShape(TRIANGLE_STRIP);
    if (previousLayer != null) {
      for (int th=0; th < subdivisions; th++) {
        float ang = TWO_PI*th / subdivisions;
        //normal(cos(ang),sin(ang),0);
        
        vertex(previousLayer[th][0], previousLayer[th][1], previousLayer[th][2]);
        vertex(thisLayer[th][0], thisLayer[th][1], thisLayer[th][2]);
      }
      vertex(previousLayer[0][0], previousLayer[0][1], previousLayer[0][2]);
      vertex(thisLayer[0][0], thisLayer[0][1], thisLayer[0][2]);
    }
    endShape();
    previousLayer = thisLayer;
    thisLayer = new float[subdivisions][3];
    
  }
  previousLayer = null;
  
  //extruderSpeed(extruderReverseSpeed);
  //extruderReverse();
  extruderStop();
  G1(X,Y,Z+20,feedRate);
  extruderStop();
}


// draw the perimeter square that sticks the filament down
void drawPerimeter() {
  comment("perimeter");
  extruderSpeed(extruderForwardSpeed);
  G1(perimeterSize/2, -perimeterSize/2, 0.5, 10);
  extruderForward();
  G1(-perimeterSize/2, -perimeterSize/2, 0.5, 10);
  G1(-perimeterSize/2, perimeterSize/2, 0.5, 10);
  G1(perimeterSize/2, perimeterSize/2, 0.5, 10);
  G1(perimeterSize/2, -perimeterSize/2.2, 0.5, 10);
  extruderSpeed(extruderReverseSpeed);
  extruderReverse();
  G1(perimeterSize/2, -perimeterSize/2, 0.5, 10);
  extruderSpeed(extruderForwardSpeed);
  //extruderStop();
  comment("/perimeter");
}

void G1(float X, float Y, float Z, float feedRate) {
  if (!saving) return;
  
  if (X<0.0001 && X>-0.0001) X = 0;
  if (Y<0.0001 && Y>-0.0001) Y = 0;
  if (Z<0.0001 && Z>-0.0001) Z = 0;
  
  X += XBIAS + XSHIFT;
  Y += YBIAS + YSHIFT;
  
  output.println("G1 X" + X + " Y" + Y + " Z" + Z + " F" + feedRate*60);
}

void extruderSpeed(float s) {
  if (!saving) return;
  
  output.println("M108 R"+s); 
  //println("extruder " + s);
}
void extruderForward() {
  if (!saving) return;
  output.println("M101");
}
void extruderReverse() {
  if (!saving) return;
  output.println("M102");
}
void extruderStop() {
  if (!saving) return;
  output.println("M103");
}

void comment(String c) {
  if (!saving) return;
  output.println("("+c+")"); 
}


void copyFile(String filename) {
  BufferedReader f = createReader(filename);
  String l;
  while (true) {
    try {
      l = f.readLine();
      if (l == null) break;
      else output.println(l);
      //println(l);
    }
    catch (IOException e) {
      e.printStackTrace();
      break;
    }
  }
}
